function varargout = dcm_simulate(varargin)
% DCM_SIMULATE M-file for dcm_simulate.fig
%      DCM_SIMULATE, by itself, creates a new DCM_SIMULATE or raises the existing
%      singleton*.
%
%      H = DCM_SIMULATE returns the handle to a new DCM_SIMULATE or the handle to
%      the existing singleton*.
%
%      DCM_SIMULATE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DCM_SIMULATE.M with the given input arguments.
%
%      DCM_SIMULATE('Property','Value',...) creates a new DCM_SIMULATE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before dcm_simulate_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to dcm_simulate_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help dcm_simulate

% Last Modified by GUIDE v2.5 21-Jun-2012 09:35:54

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @dcm_simulate_OpeningFcn, ...
                   'gui_OutputFcn',  @dcm_simulate_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before dcm_simulate is made visible.
function dcm_simulate_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to dcm_simulate (see VARARGIN)

global regions;
global stimuli;
global timepoints;
global tr;

global b;

global h3;
global c3;
global o3;
global d3;

regions = varargin{1};
stimuli = varargin{2};
timepoints = varargin{3};
tr = varargin{4};

dx    = 35;
wx    = 30;
wy    = 20;

left = 0;
dleft = 5;
top = 550;

% Intrinsic connections
% ====================================================================
for i = 1:regions
    str    = sprintf('%i',i);
    h1(i)  = uicontrol(hObject,'String',str,...
        'Style','text',...
        'HorizontalAlignment','right',...
        'Position',[left top-dx*i 20 020]);
    h2(i)  = uicontrol(hObject,'String',sprintf('%i',i),...
        'Style','text',...
        'Position',[left+dleft+dx*i top 020 020]);
end
for i = 1:regions
    for j = 1:regions
        cc=ceil([left+dleft+dx*j top+4-dx*i wx wy]);
        h3(i,j) = uicontrol(hObject,...
            'Position',cc,...
            'Style','edit');
        if i == j
            set(h3(i,j),'String','-1');
        else
            set(h3(i,j),'String','0');
        end

    end
end

% Bilinear influence
% ====================================================================
for j = 1:stimuli
    uicontrol('Style', 'pushbutton', 'String', ['B' num2str(j)],...
        'Position', [left+dx*j top-170 20 20],...
        'Callback', @btnbilinear,...
        'Value', [j]);     
end

b = zeros(regions, regions, stimuli);

% Extrinsic effects
% ====================================================================

for j = 1:stimuli
    h5(i)  = uicontrol(hObject,'String',sprintf('s%i',j),...
        'Style','text',...
        'Position',[left+dleft+dx*j top-210 020 020]);        
end

for i = 1:regions
    h4(i)  = uicontrol(hObject,'String',num2str(i),...
        'Style','text',...
        'Position',[left top-200-dx*i 20 020]);
end

for i = 1:regions
    for j = 1:stimuli
        c3(i, j)  = uicontrol(hObject,...
            'Position',[left+dleft+dx*j top-196-dx*i wx wy],...
            'Style','edit');
        set(c3(i, j),'String','0');
    end
end


% Stimulus function
% ====================================================================
h7(1) = uicontrol(hObject,'String','Onsets',...
        'Style','text',...
        'Position',[left+30 top-420 40 020]);

h7(2) = uicontrol(hObject,'String','Duration',...
        'Style','text',...
        'Position',[left+130 top-420 50 020]);
    
for i = 1:stimuli
    h6(i)  = uicontrol(hObject,'String',['s' num2str(i)],...
        'Style','text',...
        'Position',[left top-400-dx*i 20 020]);
    o3(i)  = uicontrol(hObject,...
        'Style','edit',...
        'Position',[left+30 top-400-dx*i 100 020],...
        'HorizontalAlignment', 'left',...
        'String', [num2str(round(timepoints/20)) ':' num2str(round(timepoints/5)) ':' num2str(timepoints)]);    
    d3(i)  = uicontrol(hObject,...
        'Style','edit',...
        'Position',[left+130 top-400-dx*i 100 020],...
        'HorizontalAlignment', 'left',...
        'String', num2str(round(timepoints/20)));    
    
end


drawnow

% Choose default command line output for dcm_simulate
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes dcm_simulate wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = dcm_simulate_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function btnbilinear(hObject, eventdata, handles)
global regions
global b;
global stim_nr

name = get(hObject, 'String');
stim_nr = str2double(name(2:end));
h = dcm_bilinear_matrix(b(:,:,stim_nr));
disp(b)


function updateB(hObject, eventdata, handles)
global b
global stim_nr
b(:,:,stim_nr) = handles.b;


% --- Executes on button press in btnUpdate.
function btnUpdate_Callback(hObject, eventdata, handles)
% hObject    handle to btnUpdate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
DCM = getDCM(hObject, eventdata, handles);
y      = feval(DCM.M.IS,DCM.Ep,DCM.M,DCM.U(1));
plot(y);
assignin('base','y',y);
assignin('base','U', DCM.U(1));


function edtspm_fx_fmri_Callback(hObject, eventdata, handles)
% hObject    handle to edtspm_fx_fmri (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtspm_fx_fmri as text
%        str2double(get(hObject,'String')) returns contents of edtspm_fx_fmri as a double


% --- Executes during object creation, after setting all properties.
function edtspm_fx_fmri_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtspm_fx_fmri (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtspm_gx_fmri_Callback(hObject, eventdata, handles)
% hObject    handle to edtspm_gx_fmri (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtspm_gx_fmri as text
%        str2double(get(hObject,'String')) returns contents of edtspm_gx_fmri as a double


% --- Executes during object creation, after setting all properties.
function edtspm_gx_fmri_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtspm_gx_fmri (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in btnHDefault.
function btnHDefault_Callback(hObject, eventdata, handles)
% hObject    handle to btnHDefault (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.edtspm_gx_fmri, 'String', '@spm_gx_fmri');

% --- Executes on button press in btnHIdentity.
function btnHIdentity_Callback(hObject, eventdata, handles)
% hObject    handle to btnHIdentity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.edtspm_gx_fmri, 'String', 'inline(''x'', ''x'', ''P'', ''M'', ''U'')');


function DCM = getDCM(hObject, eventdata, handles)

global regions
global stimuli
global timepoints
global tr
global b

global h3
global c3
global o3
global d3

T = 16;
dt = tr / T;

% get data 

for i = 1:regions
    for j = 1:regions
        a(i,j) = str2num(get(h3(i,j),'string'));
    end
end

for i = 1:regions
    for j = 1:stimuli
        c(i, j) = str2num(get(c3(i,j), 'string'));
    end
end

for j = 1:stimuli
    U(j).name = num2str(j);
    U(j).ons = str2num(get(o3(j), 'string'))';
    U(j).dur = str2num(get(d3(j), 'string'))';
    
    % peri-stimulus times {seconds}
    %----------------------------------------------------------------------
    pst   = [0:(timepoints-1)]*T*dt - min(U(j).ons)*tr;
    for x = 1:length(U(j).ons)
        w      = [0:(timepoints-1)]*T*dt - U(j).ons(x)*tr;
        v      = find(w >= 0);
        pst(v) = w(v);
    end    
    
    u     = U(j).ons.^0;
    if ~any(U(j).dur)
        u  = u/dt;
    end
    
    % create stimulus functions (32 bin offset)
    %======================================================================
    ton       = round(U(j).ons*tr/dt) + 33;               % onsets
    tof       = round(U(j).dur*tr/dt) + ton + 1;          % offset
    sf        = sparse((timepoints*T + 128),size(u,2));
    ton       = max(ton,1);
    tof       = max(tof,1);
    for x = 1:length(ton)
        if size(sf,1) > ton(x)
            sf(ton(x),:) = sf(ton(x),:) + u(x,:);
        end
        if size(sf,1) > tof(x)
            sf(tof(x),:) = sf(tof(x),:) - u(x,:);
        end
    end
    sf        = cumsum(sf);                         % integrate
    sf        = sf(1:(timepoints*T + 32),:);                 % stimulus    
    
    U(j).dt   = dt;         % - time bin {seconds}
    U(j).u    = sf;         % - stimulus function matrix
    if (j>1)
        U(1).u    = [U(1).u sf];
    end
    U(j).pst  = pst;        % - pst (seconds)
end    

% Copy to data structure
DCM.a   = ~(a==0);
DCM.b   = b;
DCM.c   = ~(c==0);
DCM.A   = a;
DCM.B   = b;
DCM.C   = c;
DCM.U   = U;
%DCM.xY  = xY;
DCM.v   = v;
DCM.n   = regions;
DCM.TE  = 0.04;   % default value for TE


% Unpack
%--------------------------------------------------------------------------
U     = DCM.U(1);        % inputs
n     = DCM.n;        % number of regions

% priors
%--------------------------------------------------------------------------
[pE,pC] = spm_dcm_fmri_priors(DCM.a,DCM.b,DCM.c);

pE.A = a;
pE.B = b;
pE.C = c;

DCM.Ep = pE;
DCM.pC = pC;

% Check whether the model is stable by examining the eigenvalue 
% spectrum for the intrinsic connectivity matrix 
%--------------------------------------------------------------------------
eigval = eig(DCM.Ep.A);
if max(eigval) >= 0
    fprintf('Modelled system is potentially unstable:\n');
    fprintf('Lyapunov exponent of combined connectivity matrix is %f\n',max(eigval));
    fprintf('Check the output to ensure that values are in a normal range.\n')
end

DCM.d = zeros(n,n,0);
M.IS  = 'spm_int';

% complete model specification
%--------------------------------------------------------------------------
M.f     = eval(get(handles.edtspm_fx_fmri, 'String'));
M.g     = eval(get(handles.edtspm_gx_fmri, 'String'));
M.x     = sparse(n,5);
M.pE    = pE;
M.pC    = pC;
M.m     = size(U.u,2);
M.n     = size(M.x(:),1);
M.l     = size(M.x,1);
M.N     = 32;
M.dt    = 16/M.N;
M.ns    = timepoints;
M.TE    = DCM.TE;

DCM.tr = tr;
DCM.M = M;


function setDCM(DCM, hObject, eventdata, handles)
global regions
global stimuli
global timepoints
global tr
global b

global h3
global c3
global o3
global d3

regions = size(DCM.a,1);
stimuli = size(DCM.c,2);
timepoints = DCM.M.ns;
tr = DCM.tr;

T = 16;
dt = tr / T;

% get data 

for i = 1:regions
    for j = 1:regions
        set(h3(i,j), 'String', num2str(DCM.A(i, j)));
    end
end

for i = 1:regions
    for j = 1:stimuli
        set(c3(i,j), 'String', num2str(DCM.C(i, j)));
    end
end

for j = 1:stimuli
    set(o3(j), 'string', num2str(DCM.U(j).ons'));
    set(d3(j), 'string', num2str(DCM.U(j).dur'));
end

b = DCM.b;

set(handles.edtspm_fx_fmri, 'String', ['@' func2str(DCM.M.f)]);
set(handles.edtspm_gx_fmri, 'String', ['@' func2str(DCM.M.g)]);
    
drawnow

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in btnSaveDCM.
function btnSaveDCM_Callback(hObject, eventdata, handles)
% hObject    handle to btnSaveDCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

DCM = getDCM(hObject, eventdata, handles);
[file,path] = uiputfile('*.mat','Save DCM as')

save([path file], 'DCM');

% --- Executes on button press in btnLoadDCM.
function btnLoadDCM_Callback(hObject, eventdata, handles)
% hObject    handle to btnLoadDCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[file,path] = uigetfile('*.mat','Select DCM')
load([path file]);
setDCM(DCM, hObject, eventdata, handles);


